"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var fs = require('fs');

var convertor = require('xml-js');

var Generator = /*#__PURE__*/function () {
  function Generator(baseUrl, baseComponent) {
    _classCallCheck(this, Generator);

    _defineProperty(this, "_paths", []);

    this._baseUrl = baseUrl;
    this._baseComponent = baseComponent;
  }

  _createClass(Generator, [{
    key: "_generate",
    value: function _generate() {
      this._paths = [];
      var components = [];
      components.push(this._baseComponent());

      while (components.length !== 0) {
        var component = components.pop();
        var props = component.props;

        if (props != null) {
          var children = props.children,
              path = props.path;

          if (Array.isArray(children)) {
            children === null || children === void 0 ? void 0 : children.forEach(function (child) {
              components.push(child);
            });
          } else if (children != null) {
            components.push(children);
          }

          if (path != null) {
            this._paths.push(path);
          }
        }
      }
    }
  }, {
    key: "getXML",
    value: function getXML() {
      var _this = this;

      this._generate();

      var options = {
        compact: true,
        spaces: 4
      };
      var map = {
        xml: '<?xml version="1.0" encoding="UTF-8"?>',
        urlset: {
          url: this._paths.map(function (path) {
            return {
              loc: _this._baseUrl + path,
              lastmod: '2021-01-01',
              changefreq: 'monthly',
              priority: 0.8
            };
          }),
          _attributes: {
            version: '1.0',
            encoding: 'utf-8'
          }
        }
      };
      return convertor.js2xml(map, options);
    }
  }, {
    key: "save",
    value: function save(path) {
      var xml = this.getXML();
      fs.writeFileSync(path, xml);
    }
  }]);

  return Generator;
}();

exports["default"] = Generator;